
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class League_team_playersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const league_team_players = await db.league_team_players.create(
            {
                id: data.id || undefined,
        
        joined_at: data.joined_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await league_team_players.setLeague_team( data.league_team || null, {
            transaction,
        });
        
        await league_team_players.setPlayer( data.player || null, {
            transaction,
        });
        
        await league_team_players.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return league_team_players;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const league_team_playersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                joined_at: item.joined_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const league_team_players = await db.league_team_players.bulkCreate(league_team_playersData, { transaction });

        // For each item created, replace relation files
        

        return league_team_players;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const league_team_players = await db.league_team_players.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.joined_at !== undefined) updatePayload.joined_at = data.joined_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await league_team_players.update(updatePayload, {transaction});

        
        
        if (data.league_team !== undefined) {
            await league_team_players.setLeague_team(
              
              data.league_team,
              
              { transaction }
            );
        }
        
        if (data.player !== undefined) {
            await league_team_players.setPlayer(
              
              data.player,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await league_team_players.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return league_team_players;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const league_team_players = await db.league_team_players.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of league_team_players) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of league_team_players) {
                await record.destroy({transaction});
            }
        });


        return league_team_players;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const league_team_players = await db.league_team_players.findByPk(id, options);

        await league_team_players.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await league_team_players.destroy({
            transaction
        });

        return league_team_players;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const league_team_players = await db.league_team_players.findOne(
            { where },
            { transaction },
        );

        if (!league_team_players) {
            return league_team_players;
        }

        const output = league_team_players.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.league_team = await league_team_players.getLeague_team({
            transaction
        });
        
        
        output.player = await league_team_players.getPlayer({
            transaction
        });
        
        
        output.organizations = await league_team_players.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.league_teams,
        as: 'league_team',
        
        where: filter.league_team ? {
          [Op.or]: [
            { id: { [Op.in]: filter.league_team.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.league_team.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.players,
        as: 'player',
        
        where: filter.player ? {
          [Op.or]: [
            { id: { [Op.in]: filter.player.split('|').map(term => Utils.uuid(term)) } },
            {
              display_name: {
                [Op.or]: filter.player.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.joined_atRange) {
                const [start, end] = filter.joined_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    joined_at: {
                    ...where.joined_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    joined_at: {
                    ...where.joined_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.league_team_players.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'league_team_players',
                        'joined_at',
                        query,
                    ),
                ],
            };
        }

        const records = await db.league_team_players.findAll({
            attributes: [ 'id', 'joined_at' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['joined_at', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.joined_at,
        }));
    }

    
};

